import { useForm, Controller } from 'react-hook-form'
import { Box, Button, Input, Stack } from '@chakra-ui/react'
import React, { useEffect, useRef } from 'react'
import { useDispatch } from 'react-redux'

type Inputs = {
  name: string
  age: string
}

export const FormTest = ({ name, age, onOpenModal, onCancel }) => {
  const {
    register,
    control,
    handleSubmit,
    watch,
    reset,
    setValue,
    formState: { errors },
  } = useForm<Inputs>({
    mode: 'onChange',
    defaultValues: {
      name: name,
      age: age,
    },
  })

  const onSibmit = ({ name, age }) => {
    // console.log(name, age)
  }

  const dispatch = useDispatch()

  const handleOpenModalClick = () => {
    const data = watch()
    dispatch({ type: 'OPEN_MODAL', payload: data })
    onOpenModal()
  }

  return (
    <>
      <Box
        as="form"
        flexDirection="column"
        display="flex"
        onSubmit={handleSubmit(console.log)}
      >
        <label>
          Name:
          <Controller
            control={control}
            name="name"
            rules={{
              required: 'required 4 now',
              minLength: { value: 4, message: 'min 4 now' },
            }}
            render={({ field }) => <Input {...field} />}
          />
        </label>

        <label>
          Age:
          <Controller
            control={control}
            name="age"
            render={({ field }) => (
              <Input type="number" {...field} />
            )}
          />
        </label>
        <Stack gap={4} pt={8}>
          <Button variant="solid" type="submit">
            Submit
          </Button>
          <Button variant="outline" type="button" onClick={handleOpenModalClick}>
            Продолжить в модальном окне
          </Button>
          <Button variant="ghost" type="button" onClick={onCancel}>
            Cancel
          </Button>
        </Stack>
      </Box>
    </>
  )
}
