import { HStack, Icon } from '@chakra-ui/react'
import { FaRegStar, FaStar } from 'react-icons/fa6'
import React, { useMemo, useState } from 'react'
import { getConfigValue } from '@brojs/cli'
import { useDispatch, useSelector } from 'react-redux'

import { stars } from '../__data__/context'
import { useUsers } from '../hooks'
import { setStars } from '../__data__/actions/stars'


const useStars = (currentRated, starsCount) => {
  const [rated, setRated] = useState(currentRated)
  const stars = useMemo(
    () =>
      Array.from({ length: starsCount }).map((_, index) => index + 1 > rated),
    [starsCount, rated],
  )

  return {
    setRated,
    stars,
  }
}

export const Stars = ({
  count,
  // rated,
  // setRated,
  userId,
}: {
  count: number
  userId: string
  // rated: number
  // setRated: (rate: number) => void
}) => {
  // const {
  //   stars,
  //   setRated: starsSetRated
  // } = useStars(rated, count)
  // const { setUserRate } = useUsers(state => state[userId].rated)
  const rate = useSelector((store) => store.stars.friends[userId]) ?? 0
  const dispatch = useDispatch()

  const handleStarsClick = (value: number) => {
    dispatch(setStars({ id: userId, value }))
    // setUserRate(userId, stars)
    // fetch(getConfigValue('dry-wash.api.url') + '/user-rate', {
    //   method: 'POST',
    //   headers: {
    //     'Content-Type': 'application/json',
    //   },
    //   body: JSON.stringify({
    //     userId,
    //     stars,
    //   }),
    // })
  }

  return (
    <HStack>
      {Array.from({ length: count }).map((_, index) =>
        index + 1 > rate ? (
          <Icon
            key={index}
            color="orange.400"
            cursor="pointer"
            onClick={() => handleStarsClick(index + 1)}
          >
            <FaRegStar />
          </Icon>
        ) : (
          <Icon
            key={index}
            color="orange.400"
            cursor="pointer"
            onClick={() => handleStarsClick(index + 1)}
          >
            <FaStar />
          </Icon>
        ),
      )}
    </HStack>
  )
}
