import { Container, Heading } from '@chakra-ui/react'
import React, { useEffect, useState } from 'react'
import { useParams } from 'react-router-dom'

import { Profile } from '../components'

const users = {
  'some-user-id': {
    id: 'some-user-id',
    name: 'alexandr',
    surname: null,
    email: null,
    rated: 3,
    avatar:
      'https://www.gravatar.com/avatar/6529e885535ef67a3fad810ad71167c2c03f79480936e9b3a714731753cbb47e?d=robohash',
    friends: [
      {
        id: '2',
        name: 'not alexandr',
        surname: null,
        email: null,
        rated: 2,
        avatar: 'https://www.gravatar.com/avatar/6e?d=robohash',
      },
    ],
  },
  '2': {
    id: '2',
    name: 'not alexandr',
    surname: null,
    email: null,
    rated: 2,
    avatar: 'https://www.gravatar.com/avatar/6e?d=robohash',
    friends: [
      {
        id: 'some-user-id',
        name: 'alexandr',
        surname: null,
        email: null,
        rated: 3,
        avatar:
          'https://www.gravatar.com/avatar/6529e885535ef67a3fad810ad71167c2c03f79480936e9b3a714731753cbb47e?d=robohash',
      },
    ],
  },
}

export const ByPage = () => {
  const params = useParams()
  const [isLoading, setIsLoading] = useState(null)
  const [data, setData] = useState(null)
  const [error, setError] = useState(null)

  useEffect(() => {
    const getUser = async () => {
      try {
        const response = await fetch('/api/users/' + params.userId)

        const data = await response.json()
      } catch (e) {
        alert(e.message)
      }
    }

    getUser()
  }, [])
  

  if (!users[params.userId]) {
    return <Heading as="h2">Пользователь не найден</Heading>
  }

  return <Profile key={users[params.userId].id} user={users[params.userId]} />
}
